/*****************************************************************************
    dll.h

    Diese Datei ist Teil des Programmpakets 'ACL-tftp'.
    Alle Rechte bei Andreas G. Schindler
                    Klappacher Str. 2i
                    64285 Darmstadt, Deutschland.

    Dieses Programm ist 'Freie Software'; Sie knnen es entsprechend den 
    Bedingungen der 'Allgemeinen ffentlichen GNU-Lizenz' (verffentlicht 
    durch die 'Free Software Foundation') weiter verbreiten und/oder 
    modifizieren. Massgeblich ist die Version 2 oder eine neuere Version
    dieser Lizenz. 

    Dieses Programm wird in der Hoffnung dass es ntzlich is weitergegeben,
    jedoch OHNE JEDE GARANTIE. Dieser Garantieauschluss bezieht sich auch
    auf Eigenschaften wie Marktfhigkeit oder Eignung zu einem bestimmten
    Zweck. Details finden sich in der 'Allgemeinen ffentlichen GNU-Lizenz'.

    Eine Kopie dieser Lizenz sollte in  Programmpaket, dem diese Datei
    entstammt, enthalten sein. Falls nicht, schreiben Sie an die 
    'Free Software Foundation, Inc.', 59 Temple Place, Suite 330, Boston, 
    MA  02111-1307  USA.


    This file is part of the 'ACL-tftp' Package
    Copyright (C) 1999-2005 by Andreas G. Schindler
                               Klappacher Str. 2i
                               Darmstadt, Germany.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************/
#ifndef DLL_H
#define DLL_H

#define DLL_GETNEXT	1
#define DLL_GETPREV	2
#define DLL_FREE	4
#define DLL_SORTASC	1
#define DLL_SORTDESC	2
#define DLL_CHECKPREV	1
#define DLL_CHECKNEXT	2
#define DLL_SHOWHEAD	1
#define DLL_LOOPCHECK	2
#define DLL_GETMAX	1
#define DLL_GETMIN	2
#define DLL_GETFIRST	3
#define DLL_GETLAST	4

#define CTYPE_PLAIN	1
/*
	the data[] element is a placeholder for the structure expansion
	along with several dll subtypes (see dllapps.c)

	in the head/tail condtruct, the data[] elment of head is used 
	as an element counter of the dll chain.
*/

typedef struct dll_s {	struct dll_s	*next;
			struct dll_s	*prev;
			int		ctype;
			int		mark;
			long		data[1];	} dll_t;

#define chainCount(HEAD) (((dll_t *)HEAD)->data[0])

#define DLL_HEADSIZE	(sizeof(struct dll_s)-sizeof(long))

void clearChain(dll_t *head);
void deleteChain(dll_t *head);
dll_t *initChain(dll_t *head);
int isEmptyChain(dll_t *head);
dll_t *removeElement(dll_t *elem, int flag, dll_t *head);
void clearByMark(dll_t *head, int mark);
void deleteByMark(dll_t *head, int mark, int flag);
void insertAtHead(dll_t *head, dll_t *elem);
void insertAtTail(dll_t *head, dll_t *elem);
void insertAfter(dll_t *where, dll_t *elem);
void insertBefore(dll_t *where, dll_t *elem);
void exchangeElements(dll_t *elem1, dll_t *elem2);
void sortByMark(dll_t *head, int flag);
dll_t *getByMark(dll_t *head, dll_t *start, int mark);
dll_t *getNext(dll_t *head, dll_t *start);
void dumpChain(FILE *fd, dll_t *head, dll_t *start, int flag, int bodyflag, void (* dumpbody)());
dll_t *loopCheck(dll_t *head, int flag); 
int addPlain(dll_t *head, int mark, void *data, size_t length);
dll_t *findByMark(dll_t *head, int mark, int how);
#endif /* DLL_H */


