#ifndef PARAMS_H
#define PARAMS_H
/* This file contains all the per-site configuration options
 * Change to suit local needs.  These values are used in the
 * absence of any over-riding values in the config file, and
 * are restored each time the config file is re-read.
 */
#include <fcntl.h>
#include "auto.h"	/* do NEVER		*/
#include "types.h"	/* omit these 2 !	*/


#ifndef CONFIGFILE
#define CONFIGFILE	"/usr/local/lib/tftpd.conf"
#endif

#ifndef DUMPFILE
#define DUMPFILE	"/var/tmp/tftpd.dump"
#endif

#ifndef LOGFILE
#define LOGFILE		"/var/log/tftpd"
#endif

#ifndef PIDFILE
#define PIDFILE		"/var/run/tftpd.pid"
#endif

#ifndef DEFAULTDIR
#define DEFAULTDIR	"/usr/local/tftpboot"
#endif

#ifndef LOCALEDIR
#define LOCALEDIR	"/usr/local/share/locale"
#endif

#ifndef LOCALEPACK
#define LOCALEPACK	"ACL-tftpd"
#endif

#ifndef ROOTDIR
#define ROOTDIR		NULL
#endif

#ifndef TFTPSERVICE
#define TFTPSERVICE	"tftp"
#endif

#ifndef TFTPUSER
#define TFTPUSER	"tftp"
#endif

#ifndef TFTPGROUP
#define TFTPGROUP	"nobody"
#endif

#ifndef	MESSAGELEVEL
#define MESSAGELEVEL	2
#endif

#ifndef	MAXSYSLOG
#define MAXSYSLOG	1
#endif

#ifndef LOGFACILITY	
#define LOGFACILITY	"daemon"
#endif

#ifndef FILTERMAX
#define FILTERMAX	128
#endif

#ifndef CREATEMODE
#define CREATEMODE	0660
#endif

/*	do NOT fiddle with these !	*/

#define DEFSENDTMO    2
#define DEFSACKTMO    30
#define DEFRECVTMO    30
#define DEFRACKTMO    2
#define DEFIDLETMO    10
#define DEFCONNTMO    300
 
#define MAXRETRIES    3       /* timeout cycles for ACK receive */

#define STRENGTH      10.0    /* yields consecutive timeouts of factor 1.5 */
/*                    80.0       yields consecutive timeouts of factor 2.0 */
#endif	/* PARAMS_H */
